import 'package:dart_style/dart_style.dart';
import 'package:fuzz_example_analyzer/parse_unit.dart';

void main(List<String> args) async {
  final input = args[0];
  final formatter = DartFormatter();

  String formatted;
  try {
    formatted = formatter.format(input);
  } catch (e) {
    if (e.toString().contains('could not be parsed') ||
        input.contains('@') && input.contains('<')) {
      throw 'bad seed';
    }
    rethrow;
  }

  // no try/catch this time: should not throw.
  final reformatted = formatter.format(formatted);

  if (reformatted != formatted && !formatted.contains('/*')) {
    throw 'not fixed point: $formatted\n------\n$reformatted';
  }

  final inputParse = await parseUnit(input);

  if (inputParse.errors.isEmpty) {
    // no try/catch this time either.
    final fixed = DartFormatter(fixes: StyleFix.all).format(input);

    final fixedParse = await parseUnit(fixed);
    if (fixedParse.errors.isNotEmpty) {
      throw 'fixes created errors: ${fixedParse.errors}';
    }
  }
}
